#include "MainFrame.h"
#include <wx/msgdlg.h>
#include <wx/aboutdlg.h>
#include <wx/gdicmn.h>

MainFrame::MainFrame(wxWindow* parent)
    : MainFrameBaseClass(parent)
{
}

MainFrame::~MainFrame()
{
}

void MainFrame::OnExit(wxCommandEvent& event)
{
    wxUnusedVar(event);
    Close();
}

void MainFrame::OnAbout(wxCommandEvent& event)
{
    wxUnusedVar(event);
    wxAboutDialogInfo info;
    info.SetCopyright(_("My MainFrame"));
    info.SetLicence(_("GPL v2 or later"));
    info.SetDescription(_("Short description goes here"));
    ::wxAboutBox(info);
}
void MainFrame::OnHolidaysCheckAll_ButtonClicked(wxCommandEvent& event)
{
    for(size_t i=0; i<CheckBoxes_ListBox->GetCount(); i++)
    {
        CheckBoxes_ListBox->Check((unsigned int)i, true);
    }
}
void MainFrame::OnHolidaysUncheckAll_ButtonClicked(wxCommandEvent& event)
{
    for(size_t i=0; i<CheckBoxes_ListBox->GetCount(); i++)
    {
        CheckBoxes_ListBox->Check((unsigned int)i, false);
    }
}
void MainFrame::OnBlue_RadiobuttonSelected(wxCommandEvent& event)
{
    Blue->SetValue      (true);
    Red->SetValue       (false);
    Green->SetValue     (false);
    Yellow->SetValue    (false);
}
void MainFrame::OnGreen_RadiobuttonSelected(wxCommandEvent& event)
{
    Blue->SetValue      (false);
    Red->SetValue       (false);
    Green->SetValue     (true);
    Yellow->SetValue    (false);
}
void MainFrame::OnRed_RadiobuttonSelected(wxCommandEvent& event)
{
    Blue->SetValue      (false);
    Red->SetValue       (true);
    Green->SetValue     (false);
    Yellow->SetValue    (false);
}
void MainFrame::OnYellow_RadiobuttonSelected(wxCommandEvent& event)
{
    Blue->SetValue      (false);
    Red->SetValue       (false);
    Green->SetValue     (false);
    Yellow->SetValue    (true);
}
void MainFrame::OnIcon_listboxDoubleclicked(wxCommandEvent& event)
{

    #define wxBITMAP (wxBITMAP_TYPE_ANY);

    int selectedIndex   = 0;
    int i = 7;

    //  The choices: Question Mark;Asterisk;Exclamation Point;Superman;Batman;Homer

    const   wxString    lbl_A   = "Asterisk";
    const   wxString    lbl_B   = "Batman";
    const   wxString    lbl_E   = "Exclamation Point";
    const   wxString    lbl_H   = "Homer";
    const   wxString    lbl_Q   = "Question Mark";
    const   wxString    lbl_S   = "Superman";

            wxString    label   = "";

            wxString    bmp_A   = "asterisk01.png";
            wxString    bmp_B   = "batman01.jpg";
            wxString    bmp_E   = "exclamationpoint01.png";
            wxString    bmp_H   = "homer01.png";
            wxString    bmp_Q   = "questionmark01.png";
            wxString    bmp_S   = "superman01.png";

            wxString Foobar;

                                        // Get the current index.
    selectedIndex   = Icon->GetSelection();

                                        // If the index was not found, then
                                        // return silently.
    if(selectedIndex == wxNOT_FOUND) return;

    // -------------------------------------------------------------------------
    //  Get the label for this list box item.
    // -------------------------------------------------------------------------

    label   = Icon->GetString(selectedIndex);

    Foobar.Printf(wxT("The selected Label is <%s>."), label);
    wxMessageBox( Foobar, wxT("Replace Image with Selected Image Description"), wxICON_INFORMATION);

    // Replace the image with the image corresponding to the text in the list
    // box.

    //wxBitmap bitmap(bmp_A, wxBITMAP_TYPE_ANY);

    if (label == lbl_A)
        Desired_Picture->SetBitmap (bmp_A);
    else if (label == lbl_B)
        Desired_Picture->SetBitmap (bmp_B);
    else if (label == lbl_E)
        Desired_Picture->SetBitmap (bmp_E);
    else if (label == lbl_H)
        Desired_Picture->SetBitmap (bmp_H);
    else if (label == lbl_Q)
        Desired_Picture->SetBitmap (bmp_Q);
    else if (label == lbl_S)
        Desired_Picture->SetBitmap (bmp_S);

    Desired_Picture->Refresh();

}
void MainFrame::OnIcon_listboxSelected(wxCommandEvent& event)
{

}
void MainFrame::OnHolidayscheckall_buttonButtonClicked(wxCommandEvent& event)
{
    for(size_t i=0; i<CheckBoxes_ListBox->GetCount(); i++)
    {
        CheckBoxes_ListBox->Check((unsigned int)i, true);
    }
}
void MainFrame::OnHolidaysuncheckall_buttonButtonClicked(wxCommandEvent& event)
{
    for(size_t i=0; i<CheckBoxes_ListBox->GetCount(); i++)
    {
        CheckBoxes_ListBox->Check((unsigned int)i, false);
    }
}
void MainFrame::OnPlanetsListboxDoubleclicked(wxCommandEvent& event)
{
    int         selectedIndex   = 0;
    int         i               = 0;
    wxString    Foobar          = "";
    wxString    label           = "";
    wxString    templabel       = "";

                                        // Get the current index.
    selectedIndex   = Planets->GetSelection();

    label   = Planets->GetString(selectedIndex);

    if (label == "Mercury")
        templabel   = "Mercury";
    else if (label == "Venus")
        templabel   = "Venus";
    else if (label == "Earth")
        templabel   = "Earth";
    else if (label == "Earth's Moon")
        templabel   = "Earth's Moon";
    else if (label == "Mars")
        templabel   = "Mars";
    else if (label == "Mars's Moon Diemos")
        templabel   = "Mars's Moon Diemos";
    else if (label == "Mars's Moon Phobos")
        templabel   = "Mars's Moon Phobos";
    else if (label == "The Asteroid Belt")
        templabel   = "The Asteroid Belt";
    else if (label == "Jupiter")
        templabel   = "Jupiter";
    else if (label == "Saturn")
        templabel   = "Saturn";
    else if (label == "Uranus")
        templabel   = "Uranus";
    else if (label == "Neptune")
        templabel   = "Neptune";
    else if (label == "Pluto")
        templabel   = "Pluto";

    // Yes, I know the statement below is goofy and could be done more easily.
    // The goal was to do something that would report what was selected.

    Foobar.Printf(wxT("I want to live on %s."), templabel);
    wxMessageBox( Foobar, wxT("Where I Wanna Live"), wxICON_INFORMATION);

}
